﻿namespace Datum
{
    class Datum
    {
        public byte Den
        {
            get;
            set;
        }

        public byte Mesic
        {
            get;
            set;
        }

        public ushort Rok
        {
            get;
            set;
        }

        public Datum(byte d, byte m, ushort r)
        {
            Den = d;
            Mesic = m;
            Rok = r;
        }

        public override string ToString()
        {
            return Den + ". " + Mesic + ". " + Rok;
        }

        public bool JePrestupnyRok()
        {
            if (Rok % 4 != 0)
               return false;
               else if (Rok % 100 != 0)
                       return true;
                       else if (Rok % 400 != 0)
                               return false;
                               else return true;
        }
    }

    class DatumRoz : Datum
    {
        public DatumRoz(byte d, byte m, ushort r)
            : base(d, m, r)
        {
        }

        public void PrictiDen()
        {
            if (Den < DniVMesici())
               Den++;
               else if (Mesic < 12)
                       {
                            Mesic++;
                            Den = 1;
                        }
                        else
                        {
                            Rok++;
                            Mesic = 1;
                            Den = 1;
                        }
        }

        public void OdectiDen()
        {
            if (Den > 1)
                Den--;
                else if (Mesic > 1)
                        {
                            Mesic--;
                            Den = DniVMesici();
                        }
                        else
                        {
                            Rok--;
                            Mesic = 12;
                            Den = 31;
                        }
        }

        private byte DniVMesici()
        {
            switch (Mesic)
            {
                case  1:
                case  3:
                case  5:
                case  7:
                case  8:
                case 10:
                case 12: return 31;
                case  4:
                case  6:
                case  9:
                case 11: return 30;
                case  2: if (JePrestupnyRok())
                            return 29;
                            else return 28;
                default: return 0;
            }
        }
    }
}

